; ============================================================================================

; Measures

; ============================================================================================

; =====================================================================

; Path check

; =====================================================================

[FailSafePath]
Measure=String
String=#Path_Destination#
IfMatch="^$"
IfMatchAction=[!SetVariable Error1 1][!UpdateMeterGroup ErrorText][!Redraw]

; =====================================================================

; version check

; =====================================================================

[FailSafeVer_WebParser]
Measure=WebParser
URL=#HomeURL#download.html
RegExp=(?siU)<a href="https://yt-dl.org/downloads/\d{4}\.\d{2}\.\d{2}/youtube-dl">(\d{4}\.\d{2}\.\d{2})</a>
FinishAction=[!SetVariable VerAvaliable "[FailSafeVer_CheckAvaliable]"][!UpdateMeasure FailSafeVer_Evaluate]

[FailSafeVer_CheckAvaliable]
Measure=WebParser
URL=[FailSafeVer_WebParser]
StringIndex=1

[FailSafeVer_CheckCurrent]
Measure=Plugin
Plugin=RunCommand
Parameter=#@#\youtube-dl.exe --version
OutputType=ANSI
OutputFile=#@#version.txt
RegExpSubstitute=1
Substitute="#CRLF#":""
FinishAction=[!SetVariable VerCurrent "[#CurrentSection#]"][!EnableMeasure FailSafeVer_Evaluate][!UpdateMeasure FailSafeVer_Evaluate][!UpdateMeterGroup ErrorText][!Redraw]

[FailSafeVer_Evaluate]
Measure=String
String=#VerCurrent#
IfMatch=(\d{4}\.\d{2}\.\d{2})
IfNotMatchAction=[!SetVariable Error2 1][!UpdateMeterGroup ErrorText][!Redraw]
IfMatch2=#VerAvaliable#
IfNotMatchAction2=[!SetVariable Error3 1][!UpdateMeterGroup ErrorText][!Redraw]
Disabled=1
DynamicVariables=1

; =====================================================================

; =====================================================================

[Update_RunCommand]
Measure=Plugin
Plugin=RunCommand
Parameter="#@#\youtube-dl.exe -U"

; ============================================================================================

; Meters

; ============================================================================================

; =====================================================================

; Path warning

; =====================================================================

[FailSafeMesage1]
Group=ErrorText
MeterStyle=Style_StringFailSafeMessage
Meter=String
x=((#SidebarWidth#+2*#SkinPadding#)+(#SkinWidth#-(#SidebarWidth#+2*#SkinPadding#))/2)
y=(#SkinHeight#-#SkinPadding#)
Text=The destination path is not defined.
Hidden=(#Error1#=1 ? 0 : 1)

; =====================================================================

; exe warning

; =====================================================================

[FailSafeMesage2]
Group=ErrorText
MeterStyle=Style_StringFailSafeMessage
Meter=String
x=((#SidebarWidth#+2*#SkinPadding#)+(#SkinWidth#-(#SidebarWidth#+2*#SkinPadding#))/2)
y=(#SkinHeight#-#SkinPadding#)
Text=Youtube-dl.exe has not been detected.#CRLF#Please place the youtube-dl.exe file in#CRLF#'...skins/youtube-dl/@Resources'.#CRLF##CRLF#Click the home icon to reach the download page.
Hidden=((#Error1#=0 && #Error2#=1) ? 0 : 1)
SolidColor=0,0,0,1

; =====================================================================

; Ver warning

; =====================================================================

[FailSafeMesage3]
Group=ErrorText
MeterStyle=Style_StringFailSafeMessage
Meter=String
x=((#SidebarWidth#+2*#SkinPadding#)+(#SkinWidth#-(#SidebarWidth#+2*#SkinPadding#))/2)
y=(#SkinHeight#-#SkinPadding#)
Text=There is a new version of youtube-dl avaliable.#CRLF#Click this text to download the latest version.#CRLF##CRLF#Current version - #VerCurrent##CRLF#Latest version - #VerAvaliable#
DynamicVariables=1
Hidden=(((#Error1#+#Error2#=0) && #Error3#=1) ? 0 : 1)
SolidColor=0,0,0,1
LeftMouseUpAction=[!CommandMeasure Update_RunCommand "Run"]